ScriptName rapeTattoos extends Quest
{Script for randomly adding tattoos to the player after an
aggressive sexual act}

Actor property PlayerRef auto
SexLabFramework property SexLab auto
rapeTattoos_mcm property menuForm auto

int missedChances = 0
Bool IsZazInstalled = false
Faction ZazSlaveFaction

string defaultGroup = "(excluded)"

Event OnInit()
	Debug.Notification("RapeTattoos Loaded")
	doEveryGameLoad()
	
	RegisterForKey(49) ; N Key
EndEvent

function doEveryGameLoad()
	;Debug.Notification("RapeTattoos Game Load Function Called")
	RegisterForModEvent("AnimationEnd","aniEndHook")
	RegisterForModEvent("RapeTattoos_addTattoo","addTattooEvent")
	If Game.GetModByName("ZaZAnimationPack.esm") != 255
		ZazSlaveFaction = Game.GetFormFromFile(0x000096AE, "ZaZAnimationPack.esm") as Faction
		IsZazInstalled = true
	Else
		IsZazInstalled = false
	EndIf
endfunction

; TODO add event with target specifier

event addTattooEvent(string eventName, string argString, float argNum, form sender)
	;Debug.Notification("Event caught")
	doTattooAction()
endevent

Event OnKeyUp(int keyCode, float holdTime)
	if keyCode == 49 && menuForm.debugEnabled
		Debug.Notification("Debug Key pressed - Adding Tattoo")
		doTattooAction()
	endIf
endEvent

; This function handles all context independant actor eligibility tests
bool function isValidTattooTarget(Actor candidate)
    if candidate == None
        return false
    endif
    
    ; NPC Check
    if !menuForm.allowNPC && candidate != PlayerRef 
        return false
    endif
    
    ; Gender Check
    int gender = Math.LogicalAnd(SexLab.getGender(candidate), 1)
    if (!menuForm.allowMale && gender == 0) || (!menuForm.allowFemale && gender == 1)
        return false
    endif
    
    return true
endfunction

event aniEndHook(string eventName, string argString, float argNum, form sender)
    Actor[] actorList = SexLab.HookActors(argString)
    if SexLab.CreatureCount(actorList) > 0 && menuForm.excludeBeastiality
        ; Ignore sex scene
        return
    endif
    
    if menuForm.onlyVictim
        ; Only consider victim
        Actor victim = Sexlab.HookVictim(argString)
        if isValidTattooTarget(victim)
            maybeTriggerFor(victim)
        endif
    else
        ; Check all actors
        int i = actorList.Length - 1
        while i >= 0
            if isValidTattooTarget(actorList[i])
                maybeTriggerFor(actorList[i])
            endif
            i -= 1
        endwhile
    endif
endEvent

function maybeTriggerFor(Actor target)
    float curChance
	If target == PlayerRef
		curChance = menuForm.baseChance + (missedChances as float)*(menuForm.chanceIncrease as float)
	Else
		If IsZazInstalled
			If target.IsInFaction(ZazSlaveFaction)
				curChance = menuForm.ZazbaseChance + (missedChances as float)*(menuForm.chanceIncrease as float) ; Zaz slave
			Else
				curChance = menuForm.NpcbaseChance + (missedChances as float)*(menuForm.chanceIncrease as float) ; Normal NPC
			EndIf
		Else
			curChance = menuForm.NpcbaseChance + (missedChances as float)*(menuForm.chanceIncrease as float) ; Normal NPC
		EndIf
	EndIf
	
	if Utility.RandomFloat() < curChance
		if doTattooActionFor(target)
            if PlayerRef != target && menuForm.enableNPCNotification
               string targetName = target.GetActorBase().GetName()
               Debug.Notification("" + targetName + " got tattooed")
            endif
            
			if menuForm.enableNotification && PlayerRef == target
				Debug.Notification("Your last partner left you a memento...")
			endif
			missedChances = 0
		else
			missedChances += 1
		endIf
	else
		missedChances += 1
	endIf
endfunction

; Returns retained JMap mapping texture paths to a sub-jmap with extra data
int function getDataMap() global
	int dataMap = JValue.readFromFile(JContainers.userDirectory() + "rTats/settings.json")
	if dataMap == 0
		; File does not exist yet, use template
		dataMap = JValue.readFromFile("Data/rTatsSettingsTemplate.json")
	endif
	return JValue.retain(dataMap)
endfunction

string function getGroupForEntry(int dataMap, int tattooEntry)
	int extraData = JMap.getObj(dataMap,JMap.getStr(tattooEntry,"texture"))
	if extraData == 0
		return defaultGroup
	else
		string groupName = JMap.getStr(extraData,"group")
		if groupName == ""
			groupName = defaultGroup
		endif
		return groupName
	endif
endfunction

; Returns retained JArray with Tattoo entries
; Tattoo entries may be modified from their default state
; (color, gloss, glow etc)
int function getAdjustedTattooArray()
	int template = JValue.retain(JMap.object())
	int matches = JValue.retain(JArray.object())
	if SlaveTats.query_available_tattoos(template,matches)
		; Error Occurred, ignore for now
	endif
	JValue.release(template)
	
	int i = JArray.count(matches) - 1
	int tattooEntry
	int tempInt
	string tempStr
	string tattooGroup
	while i >= 0
		tattooEntry = JArray.getObj(matches,i)
		
		; Overwrites some properties
		if menuForm.overwriteColor
			JMap.setInt(tattooEntry, "color", menuForm.tattooColor)
		endif
		
		if menuForm.overwriteGloss
			JMap.setInt(tattooEntry, "gloss", 0)
		elseif menuForm.forceGloss
			JMap.setInt(tattooEntry, "gloss", 1)
		endif
		
		if menuForm.overwriteGlow
			JMap.setInt(tattooEntry, "glow", 0)
		elseif menuForm.forceGlow
			JMap.setInt(tattooEntry, "glow", menuForm.glowColor)
		endif
		
        if menuForm.useLockedTats
            JMap.setInt(tattooEntry, "locked", 1)
        endif
        
		i -= 1
	endwhile
	
	return matches
endfunction

; Takes a retained JArray of tattoo entries, as formatted from getAdjustedTattooArray()
; and removes any entries that:
; - Share the texture of an applied tattoo
; - Share the group of an applied tattoo (unless it's the special "(unassigned)" group)
; - Is part of the "(excluded)" group
int function filterTattooArray(int adjustedList, Actor target, int dataMap)
	; Get list of currently applied tattoos
	int template = JValue.retain(JMap.object())
	int appliedTattoos = JValue.retain(JArray.object())
	if SlaveTats.query_applied_tattoos(target, template, appliedTattoos)
		; Error Occurred, ignore for now
	endif
	JValue.release(template)
	
	; Get set of applied groups
	int appliedGroups = JValue.retain(JArray.object())
	int i = JArray.count(appliedTattoos) - 1
	int currentEntry
	string group
	while i >= 0
		; Determine group of tattoo
		currentEntry = JArray.getObj(appliedTattoos,i)
		group = getGroupForEntry(dataMap,currentEntry)
		
		; If this group is not already in the list, add it
		if JArray.findStr(appliedGroups,group) == -1
			JArray.addStr(appliedGroups,group) 
		endif
		i -= 1
	endwhile
	
	; Goes through list and removes entries that don't match criteria
	i = JArray.count(adjustedList) - 1
	bool excluded
	int j
	string texturePath
	while i >= 0
		excluded = False
		
		; Determine group of tattoo
		currentEntry = JArray.getObj(adjustedList,i)
		group = getGroupForEntry(dataMap,currentEntry)
		
		if group == "(excluded)"
			; Part of manually excluded group
			excluded = True
		elseif group != "(unassigned)" && JArray.findStr(appliedGroups,group) != -1
			; Part of excludeable group of which a tattoo has already been applied
			excluded = True
		else
			texturePath = JMap.getStr(currentEntry,"texture")
			j = JArray.count(appliedTattoos) - 1
			while j >= 0
				if texturePath == JMap.getStr(JArray.getObj(appliedTattoos,j),"texture")
					; A tattoo with this texture path has already been applied
					excluded = True
					j = -1
				endif
				j -= 1
			endwhile
		endif
			
		if excluded
			; Remove entry from list/array
			JArray.eraseIndex(adjustedList,i)
		endif
		
		i -= 1
	endwhile
	
	; Release temporary resources
	JValue.release(appliedTattoos)
	JValue.release(appliedGroups)
	
	return adjustedList
endfunction

bool function doTattooAction()
    return doTattooActionFor(Game.GetPlayer())
endfunction

bool function doTattooActionFor(Actor target)
	bool retValue = True
	int dataMap = getDataMap()
	int adjustedList = getAdjustedTattooArray()
	filterTattooArray(adjustedList,target,dataMap)
	
	if JArray.count(adjustedList) == 0
		Debug.Notification("No valid tattoos available")
		retValue = false
	else
		int chosenEntry = JArray.getObj(adjustedList,Utility.RandomInt(0,JArray.count(adjustedList)))
		
		if SlaveTats.add_tattoo(target, chosenEntry, -1, ignore_lock=false, silent=true)
			retValue = false
			
		; Player
		elseif !menuForm.permanentTattoos && target == PlayerRef
			; If tattoo got added successfully and this is a non-permanent tattoo, register for fade-out
			fadeTattoos.doAlphaFadeForTarget(target,JMap.getStr(chosenEntry,"texture"),menuForm.tattooDurationHours)
		
		; NPCs
		elseif target != PlayerRef
			If IsZazInstalled
				If target.IsInFaction(ZazSlaveFaction) && !menuForm.ZazpermanentTattoos ; Zaz Slave
					fadeTattoos.doAlphaFadeForTarget(target,JMap.getStr(chosenEntry,"texture"),menuForm.ZaztattooDurationHours)
				ElseIf !target.IsInFaction(ZazSlaveFaction) && !menuForm.NpcpermanentTattoos ; NOT a Zaz slave
					fadeTattoos.doAlphaFadeForTarget(target,JMap.getStr(chosenEntry,"texture"),menuForm.NpctattooDurationHours)
				EndIf
				
			Else
				If !menuForm.NpcpermanentTattoos
					; If tattoo got added successfully and this is a non-permanent tattoo, register for fade-out
					fadeTattoos.doAlphaFadeForTarget(target,JMap.getStr(chosenEntry,"texture"),menuForm.NpctattooDurationHours)
				EndIf
			EndIf
		endif
		SlaveTats.synchronize_tattoos(target, true)
		
		; Tattoo successfully applied
	endif
	
	JValue.release(dataMap)
	JValue.release(adjustedList)
	return retValue
endfunction