scriptname rapeTattoos_mcm extends SKI_ConfigBase

; OIDs
int baseChanceOID
int NpcbaseChanceOID
int ZazbaseChanceOID
int chanceIncreaseOID
int tattooDurationOID
int NpctattooDurationOID
int ZaztattooDurationOID

int debugOID
int permanentTattoosOID
int NpcpermanentTattoosOID
int ZazpermanentTattoosOID
int enableNotificationOID

int overwriteColorOID
int tattooColorOID
int overwriteGlossOID
int overwriteGlowOID

int glowColorOID
int forceGlossOID
int forceGlowOID

int allowFemaleOID
int allowMaleOID
int allowNPCOID
int onlyVictimOID
int excludeBeastialityOID

int enableNPCNotificationOID
int useLockedTatsOID

float property baseChance = 0.10 auto hidden
float property NpcbaseChance = 0.20 auto hidden
float property ZazbaseChance = 0.50 auto hidden
float property chanceIncrease = 0.07 auto hidden
float property tattooDurationHours = 168.0 auto hidden
float property NpctattooDurationHours = 336.0 auto hidden
float property ZaztattooDurationHours = 672.0 auto hidden
float property tattooDuration = 7.0 auto hidden

bool property debugEnabled = False auto hidden
bool property permanentTattoos = False auto hidden
bool property NpcpermanentTattoos = False auto hidden
bool property ZazpermanentTattoos = False auto hidden
bool property enableNotification = True auto hidden

bool property overwriteColor = True auto hidden
int property tattooColor = 0 auto hidden
bool property overwriteGloss = True auto hidden
bool property overwriteGlow = True auto hidden
int property glowColor = 0 auto hidden
bool property forceGloss = False auto hidden
bool property forceGlow = False auto hidden

bool property allowFemale = True auto hidden
bool property allowMale = False auto hidden
bool property allowNPC = False auto hidden
bool property onlyVictim = True auto hidden
bool property excludeBeastiality = True auto hidden

bool property enableNPCNotification = True auto hidden
bool property useLockedTats = False auto hidden

int firstTattooPageIdx
int tattooPageCount
int tattoosPerPage = 50

int tattooList = 0
int currentlyAppliedList = 0
int applyQueue = 0
int removeQueue = 0
int tattooOIDToIdxMap = 0
int tattooTextureOIDToIdxMap = 0
int tattooExtraDataMap = 0
string[] tattooGroups
string[] tattooFadeModes

string[] potentialPages

string[] appliedOptions

event OnConfigInit()
    potentialPages = new string[128]
    potentialPages[0] = "General"
	potentialPages[1] = "Tattoo Setting Explanation"
	
	firstTattooPageIdx = 2
	tattooPageCount = 126
	int i = firstTattooPageIdx
	int count = 1
	while i < firstTattooPageIdx + tattooPageCount
		potentialPages[i] = "Tattoos Page " + count
		count += 1
		i += 1
	endwhile
	
	; Temporary measure
	Pages = potentialPages
	
	appliedOptions = new string[2]
	appliedOptions[0] = "Not Applied"
	appliedOptions[1] = "Applied"
	
	tattooGroups = new string[39]
	tattooGroups[0] = "(unassigned)"
	tattooGroups[1] = "(excluded)"
	tattooGroups[2] = "tally"
	tattooGroups[3] = "forehead"
	tattooGroups[4] = "face"
	tattooGroups[5] = "mouth"
	tattooGroups[6] = "shoulder"
	
	tattooGroups[7] = "left arm"
	tattooGroups[8] = "right arm"
	tattooGroups[9] = "left hand"
	tattooGroups[10] = "right hand"
	tattooGroups[11] = "hands"
	
	tattooGroups[12] = "breasts"
	tattooGroups[13] = "left breast"
	tattooGroups[14] = "right breast"
	tattooGroups[15] = "front middle"
	tattooGroups[16] = "front lower"
	
	tattooGroups[17] = "upper back"
	tattooGroups[18] = "middle back"
	tattooGroups[19] = "lower back"
	
	tattooGroups[20] = "pubic"
	tattooGroups[21] = "butt"
	tattooGroups[22] = "left cheek"
	tattooGroups[23] = "right cheek"
	tattooGroups[24] = "left leg"
	tattooGroups[25] = "right leg"
	tattooGroups[26] = "feet"
	
	tattooGroups[27] = "misc 1 - a"
	tattooGroups[28] = "misc 1 - b"
	tattooGroups[29] = "misc 1 - c"
	tattooGroups[30] = "misc 1 - d"
	tattooGroups[31] = "misc 2 - a"
	tattooGroups[32] = "misc 2 - b"
	tattooGroups[33] = "misc 2 - c"
	tattooGroups[34] = "misc 2 - d"
	tattooGroups[35] = "misc 3 - a"
	tattooGroups[36] = "misc 3 - b"
	tattooGroups[37] = "misc 3 - c"
	tattooGroups[38] = "misc 3 - d"
endEvent

function setTruePageSet(int tattooCount)
	tattooPageCount = 0
	while tattooPageCount*tattoosPerPage < tattooCount
		tattooPageCount += 1
	endwhile
	if tattooPageCount > 126
		tattooPageCount = 126
	endif
	
	; Assign array of correct size
	int totalPages = tattooPageCount + 2
	Pages = getStringArray(totalPages)
	
	; Copy over page name data
	int i = 0
	while i < totalPages
		Pages[i] = potentialPages[i]
		i += 1
	endwhile
	
endfunction

; Note to anyone reading this:
; If you know of an alternative to this horrible hack please tell me
string[] function getStringArray(int size)
	if size == 1
		return new string[1]
	elseif size == 2
		return new string[2]
	elseif size == 3
		return new string[3]
	elseif size == 4
		return new string[4]
	elseif size == 5
		return new string[5]
	elseif size == 6
		return new string[6]
	elseif size == 7
		return new string[7]
	elseif size == 8
		return new string[8]
	elseif size == 9
		return new string[9]
	elseif size == 10
		return new string[10]
	elseif size == 11
		return new string[11]
	elseif size == 12
		return new string[12]
	elseif size == 13
		return new string[13]
	elseif size == 14
		return new string[14]
	elseif size == 15
		return new string[15]
	elseif size == 16
		return new string[16]
	elseif size == 17
		return new string[17]
	elseif size == 18
		return new string[18]
	elseif size == 19
		return new string[19]
	elseif size == 20
		return new string[20]
	elseif size == 21
		return new string[21]
	elseif size == 22
		return new string[22]
	elseif size == 23
		return new string[23]
	elseif size == 24
		return new string[24]
	elseif size == 25
		return new string[25]
	elseif size == 26
		return new string[26]
	elseif size == 27
		return new string[27]
	elseif size == 28
		return new string[28]
	elseif size == 29
		return new string[29]
	elseif size == 30
		return new string[30]
	elseif size == 31
		return new string[31]
	elseif size == 32
		return new string[32]
	elseif size == 33
		return new string[33]
	elseif size == 34
		return new string[34]
	elseif size == 35
		return new string[35]
	elseif size == 36
		return new string[36]
	elseif size == 37
		return new string[37]
	elseif size == 38
		return new string[38]
	elseif size == 39
		return new string[39]
	elseif size == 40
		return new string[40]
	elseif size == 41
		return new string[41]
	elseif size == 42
		return new string[42]
	elseif size == 43
		return new string[43]
	elseif size == 44
		return new string[44]
	elseif size == 45
		return new string[45]
	elseif size == 46
		return new string[46]
	elseif size == 47
		return new string[47]
	elseif size == 48
		return new string[48]
	elseif size == 49
		return new string[49]
	elseif size == 50
		return new string[50]
	elseif size == 51
		return new string[51]
	elseif size == 52
		return new string[52]
	elseif size == 53
		return new string[53]
	elseif size == 54
		return new string[54]
	elseif size == 55
		return new string[55]
	elseif size == 56
		return new string[56]
	elseif size == 57
		return new string[57]
	elseif size == 58
		return new string[58]
	elseif size == 59
		return new string[59]
	elseif size == 60
		return new string[60]
	elseif size == 61
		return new string[61]
	elseif size == 62
		return new string[62]
	elseif size == 63
		return new string[63]
	elseif size == 64
		return new string[64]
	elseif size == 65
		return new string[65]
	elseif size == 66
		return new string[66]
	elseif size == 67
		return new string[67]
	elseif size == 68
		return new string[68]
	elseif size == 69
		return new string[69]
	elseif size == 70
		return new string[70]
	elseif size == 71
		return new string[71]
	elseif size == 72
		return new string[72]
	elseif size == 73
		return new string[73]
	elseif size == 74
		return new string[74]
	elseif size == 75
		return new string[75]
	elseif size == 76
		return new string[76]
	elseif size == 77
		return new string[77]
	elseif size == 78
		return new string[78]
	elseif size == 79
		return new string[79]
	elseif size == 80
		return new string[80]
	elseif size == 81
		return new string[81]
	elseif size == 82
		return new string[82]
	elseif size == 83
		return new string[83]
	elseif size == 84
		return new string[84]
	elseif size == 85
		return new string[85]
	elseif size == 86
		return new string[86]
	elseif size == 87
		return new string[87]
	elseif size == 88
		return new string[88]
	elseif size == 89
		return new string[89]
	elseif size == 90
		return new string[90]
	elseif size == 91
		return new string[91]
	elseif size == 92
		return new string[92]
	elseif size == 93
		return new string[93]
	elseif size == 94
		return new string[94]
	elseif size == 95
		return new string[95]
	elseif size == 96
		return new string[96]
	elseif size == 97
		return new string[97]
	elseif size == 98
		return new string[98]
	elseif size == 99
		return new string[99]
	elseif size == 100
		return new string[100]
	elseif size == 101
		return new string[101]
	elseif size == 102
		return new string[102]
	elseif size == 103
		return new string[103]
	elseif size == 104
		return new string[104]
	elseif size == 105
		return new string[105]
	elseif size == 106
		return new string[106]
	elseif size == 107
		return new string[107]
	elseif size == 108
		return new string[108]
	elseif size == 109
		return new string[109]
	elseif size == 110
		return new string[110]
	elseif size == 111
		return new string[111]
	elseif size == 112
		return new string[112]
	elseif size == 113
		return new string[113]
	elseif size == 114
		return new string[114]
	elseif size == 115
		return new string[115]
	elseif size == 116
		return new string[116]
	elseif size == 117
		return new string[117]
	elseif size == 118
		return new string[118]
	elseif size == 119
		return new string[119]
	elseif size == 120
		return new string[120]
	elseif size == 121
		return new string[121]
	elseif size == 122
		return new string[122]
	elseif size == 123
		return new string[123]
	elseif size == 124
		return new string[124]
	elseif size == 125
		return new string[125]
	elseif size == 126
		return new string[126]
	elseif size == 127
		return new string[127]
	else
		return new string[128]
	endif
endfunction

event OnConfigOpen()
	; Tattoo list should only get generated once per menu viewing
	tattooList = getAvailableTattoos()
	
	setTruePageSet(JArray.count(tattooList))
	
	; Creates JMap for connecting the OID of tattoo elements to the tattoo idx
	tattooOIDToIdxMap = JValue.retain(JIntMap.object())
	tattooTextureOIDToIdxMap = JValue.retain(JIntMap.object())
	
	currentlyAppliedList = getAppliedSubset(tattooList)
	applyQueue = JValue.retain(JArray.object())
	removeQueue = JValue.retain(JArray.object())
	
	tattooExtraDataMap = JValue.readFromFile(JContainers.userDirectory() + "rTats/settings.json")
	if tattooExtraDataMap == 0
		; File does not exist yet, use template
		tattooExtraDataMap = JValue.readFromFile("Data/rTatsSettingsTemplate.json")
	endif
	tattooExtraDataMap = JValue.retain(tattooExtraDataMap)
endEvent

event OnConfigClose()
	JValue.writeToFile(tattooExtraDataMap, JContainers.userDirectory() + "rTats/settings.json")
	
	menu_performQueuedActions()
	
	JValue.release(tattooList)
	JValue.release(currentlyAppliedList)
	JValue.release(applyQueue)
	JValue.release(removeQueue)
	JValue.release(tattooOIDToIdxMap)
	JValue.release(tattooTextureOIDToIdxMap)
	JValue.release(tattooExtraDataMap)
endEvent

; Returns new and retained JArray
; with subset of tattoos that are currently applied
int function getAppliedSubset(int fullList)
	int subsetList = JValue.retain(JArray.object())
	int appliedList = JFormDB.getObj(Game.GetPlayer(), ".SlaveTats.applied")
	
	int i = JArray.count(fullList) - 1
	int currentTattoo
	int j
	while i >= 0
		currentTattoo = JArray.getObj(fullList,i)
		j = JArray.count(appliedList) - 1
		while j >=0
			if JMap.getStr(JArray.getObj(appliedList,j),"texture") == JMap.getStr(currentTattoo,"texture")
				JArray.addObj(subsetList,currentTattoo)
				j = -1
			endif
			j -= 1
		endwhile
		
		i -= 1
	endwhile
	
	return subsetList
endfunction

; The menu_ family of function allows you to perform
; isApplied, add, & remove actions while the menu is open without
; immediately making the actual changes.
; The main reason for this is that adding or removing any tattoo will stall the menu
; requiring the user to restart it, but it's also a more efficient method all around

bool function menu_isTattooApplied(int tattooEntry)
	bool check1 = JArray.findObj(currentlyAppliedList,tattooEntry) != -1
	bool check2 = JArray.findObj(applyQueue,tattooEntry) != -1
	bool check3 = JArray.findObj(removeQueue,tattooEntry) == -1
	return (check1 || check2) && check3
endfunction

function menu_applyTattoo(int tattooEntry)
	; If not already applied, add to apply queue and remove from remove queue if necessary
	if !menu_isTattooApplied(tattooEntry)
		JArray.addObj(applyQueue,tattooEntry)
		int i = JArray.findObj(removeQueue,tattooEntry)
		if i != -1
			JArray.eraseIndex(removeQueue,i)
		endif
	endif
endfunction

function menu_removeTattoo(int tattooEntry)
	; If applied, add to remove queue and remove from add queue if necessary
	if menu_isTattooApplied(tattooEntry)
		JArray.addObj(removeQueue,tattooEntry)
		int i = JArray.findObj(applyQueue,tattooEntry)
		if i != -1
			JArray.eraseIndex(applyQueue,i)
		endif
	endif
endfunction

; Perform queued applications and removals
function menu_performQueuedActions()
	Actor playerRef = Game.GetPlayer()
	int tatRef
	int temp
	
	int i = JArray.count(applyQueue) - 1
	while i >= 0
		tatRef = JArray.getObj(applyQueue,i)
		; Add tattoo
		SlaveTats.add_tattoo(playerRef,tatRef)
		
		; Update currentlyAppliedList
		JArray.addObj(currentlyAppliedList,tatRef)
		i -= 1
	endwhile
	JArray.clear(applyQueue)
	
	i = JArray.count(removeQueue) - 1
	while i >= 0
		tatRef = JArray.getObj(removeQueue,i)
		; Remove tattoo
		SlaveTats.remove_tattoos(playerRef,tatRef)
		
		; Update currentlyAppliedList
		temp = JArray.findObj(currentlyAppliedList,tatRef)
		if temp != -1
			JArray.eraseIndex(currentlyAppliedList,temp)
		endif
		i -= 1
	endwhile
	JArray.clear(removeQueue)
	
	SlaveTats.synchronize_tattoos(playerRef,silent=True)
endfunction

function setGroupForTattoo(int tattooEntry, string groupName)
	string tattooKey = JMap.getStr(tattooEntry,"texture")
	int tattooExtraData = JMap.getObj(tattooExtraDataMap,tattooKey)
	if tattooExtraData == 0
		; No data exists for this tattoo yet, create new JMap
		; Since this object is added as a member of another JMap, we do not need
		; to call retain()
		tattooExtraData = JMap.object()
		JMap.setObj(tattooExtraDataMap,tattooKey,tattooExtraData)
	endif
	JMap.setStr(tattooExtraData,"group",groupName)
endfunction

string function getGroupForTattoo(int tattooEntry)
	string tattooKey = JMap.getStr(tattooEntry,"texture")
	int tattooExtraData = JMap.getObj(tattooExtraDataMap,tattooKey)
	if tattooExtraData == 0
		; No entry exists for this tattoo yet, use default group
		return tattooGroups[1]
	else
		string groupName = JMap.getStr(tattooExtraData,"group")
		if groupName == ""
			; No group entry exists for this tattoo yet, use default group
			groupName = tattooGroups[1]
		endif
		return groupName
	endif
endfunction

int function getIndexForGroup(string groupName)
	int i = 0
	while i < tattooGroups.length
		if tattooGroups[i] == groupName
			return i
		endif
		i += 1
	endwhile
	return -1
endfunction

; Returns retained JArray with available tattoo JMaps
int function getAvailableTattoos()
	int template = JValue.retain(JMap.object(), "rapeTattoos")
	int matches = JValue.retain(JArray.object(), "rapeTattoos")
	if SlaveTats.query_available_tattoos(template,matches)
		; Error Occurred, ignore for now
	endif
	JValue.release(template)
	
	; Sorts tattoo entries alphabetically by the texture path
	; I'm sort-of assuming that no two tattoos with share the same .dds file
	sortJArrayByStringKey(matches,"texture")
	return matches
	
endfunction

function sortJArrayByStringKey(int dataList, string sortKey)
	_sortJArrayByStringKey(dataList,sortKey,0,JArray.count(dataList))
endfunction

; Sorts a section of the JArray using the mergesort algorithm
function _sortJArrayByStringKey(int dataList, string sortKey, int startIndex, int indexLimit)
	if indexLimit - startIndex < 2
		; Section of size <1, so automatically sorted
		return
	else
		; Note: indexLimit - startIndex >= 2
		int splitIndex = startIndex + (indexLimit - startIndex) / 2
		
		; Sort both halves recursively
		_sortJArrayByStringKey(dataList,sortKey,startIndex,splitIndex)
		_sortJArrayByStringKey(dataList,sortKey,splitIndex,indexLimit)
		
		; Merge sorted sides
		int mainIdx = startIndex
		int segOneIdx = startIndex
		int segTwoIdx = splitIndex
		while mainIdx < indexLimit && segOneIdx < splitIndex && segTwoIdx < indexLimit
			if JMap.getStr(JArray.getObj(dataList,segOneIdx),sortKey) < JMap.getStr(JArray.getObj(dataList,segTwoIdx),sortKey)
				; Use the segment one value
				segOneIdx += 1
			else
				; Use the segment two value
				_moveItemForward(dataList,segOneIdx,segTwoIdx)
				segOneIdx += 1
				segTwoIdx += 1
			endif
			mainIdx += 1
		endwhile
	endif
endfunction

; Moves item from oldIdx to lowerIdx and shuffles the items from lowerIdx to oldIdx backwards
; Ex: a b c d -> a d b c
function _moveItemForward(int dataList, int lowerIdx, int oldIdx)
	while lowerIdx < oldIdx
		JArray.swapItems(dataList,lowerIdx,oldIdx)
		lowerIdx += 1
	endwhile
endfunction

event OnPageReset(string page)
	int i
	
	SetCursorFillMode(TOP_TO_BOTTOM)
	SetCursorPosition(0)
	
	if page == Pages[0] || page == ""
		AddHeaderOption("General Settings")
		baseChanceOID = AddSliderOption("Base Chance",baseChance,"{2}")
		NpcbaseChanceOID = AddSliderOption("Npc Base Chance",NpcbaseChance,"{2}")
		ZazbaseChanceOID = AddSliderOption("Zaz Base Chance",ZazbaseChance,"{2}")
		chanceIncreaseOID = AddSliderOption("Chance Increase per act",chanceIncrease,"{2}")
		AddEmptyOption()
		
		permanentTattoosOID = AddToggleOption("Tattoos are permanent",permanentTattoos)
		NpcpermanentTattoosOID = AddToggleOption("NPC Tattoos are permanent",NpcpermanentTattoos)
		ZazpermanentTattoosOID = AddToggleOption("Zaz Tattoos are permanent",ZazpermanentTattoos)
        useLockedTatsOID = AddToggleOption("Tattoos are 'locked'",useLockedTats)
        
		tattooDurationOID = AddSliderOption("Duration 'tattoos' last in hours",tattooDurationHours,"{1}")
		NpctattooDurationOID = AddSliderOption("Npc Duration 'tattoos' last in hours",NpctattooDurationHours,"{1}")
		ZaztattooDurationOID = AddSliderOption("Zaz Duration 'tattoos' last in hours",ZaztattooDurationHours,"{1}")
		AddEmptyOption()
		
		enableNotificationOID = AddToggleOption("Notification upon new player tattoo",enableNotification)
        enableNPCNotificationOID = AddToggleOption("Notification upon new NPC tattoo",enableNPCNotification)
		
        AddHeaderOption("Eligibility Options")
        allowFemaleOID = AddToggleOption("Females",allowFemale)
        allowMaleOID = AddToggleOption("Males",allowMale)
        allowNPCOID = AddToggleOption("NPCs",allowNPC)
        AddEmptyOption()
        onlyVictimOID = AddToggleOption("Only when victim",onlyVictim)
        excludeBeastialityOID = AddToggleOption("Ignore scenes with animals",excludeBeastiality)
        
		SetCursorPosition(1)
		AddHeaderOption("Overwrite Tattoo Properties")
		overwriteColorOID = AddToggleOption("Force Color",overwriteColor)
		tattooColorOID = AddColorOption("Forced Tattoo Color",tattooColor)
		overwriteGlossOID = AddToggleOption("Force No Gloss",overwriteGloss)
		overwriteGlowOID = AddToggleOption("Force No Glow",overwriteGlow)
		AddEmptyOption()
		forceGlossOID = AddToggleOption("Force Gloss",forceGloss)
		glowColorOID = AddColorOption("Forced Glow Color",glowColor)
		forceGlowOID = AddToggleOption("Force Glow",forceGlow)
		AddEmptyOption()
		AddHeaderOption("Debug Options")
		debugOID = AddToggleOption("Debug Mode Enabled",debugEnabled)
		return
	elseif page == potentialPages[1]
		SetCursorFillMode(LEFT_TO_RIGHT) 
		AddHeaderOption("Information About Tattoo Setting Pages")
		AddEmptyOption()
		
		AddTextOption("Depending on how many tattoos you have installed,","")
		AddTextOption("you will see multiple tattoo setting pages.","")
		
		AddTextOption("Each page is identical apart from the tattoos it","")
		AddTextOption("manages.","")
		
		AddTextOption("There are 50 tattoos per page,","")
		AddTextOption("and a maximum of 126 pages","")
		
		AddTextOption("(If you have more than 6300 tattoos installed,","")
		AddTextOption("you might be out of luck.)","")
		
		AddTextOption("If no tattoos were detected you won't see any","")
		AddTextOption("tattoo setting pages","")
		
		AddEmptyOption()
		AddEmptyOption()
		
		AddTextOption("The tattoo page lets to do two things:","")
		AddEmptyOption()
		
		AddTextOption("Assign tattoos to 'groups' and manually","")
		AddTextOption("add/remove them","")
		
		AddHeaderOption("Tattoo Groups")
		AddEmptyOption()
		
		AddTextOption("Without groups, randomly adding tattoos quickly","")
		AddTextOption("results in multiple tattoos occupying the same","")
		
		AddTextOption("space and being unreadable.","")
		AddEmptyOption()
		
		AddTextOption("To prevent this problem, each tattoo has a 'group'","")
		AddTextOption("property which indicates the area of the body it","")
		
		AddTextOption("gets applied to.","")
		AddEmptyOption()
		
		AddTextOption("Only one tattoo from each group will be applied.","")
		AddEmptyOption()
		
		AddEmptyOption()
		AddEmptyOption()
		AddTextOption("There are also two special groups: '(unassigned)'","")
		AddTextOption("and '(excluded)'","")
		
		AddTextOption("'(unassigned)' is the default group and is the","")
		AddTextOption("only group that allows multiple tattoos to be","")
		
		AddTextOption("applied","")
		AddEmptyOption()
		
		AddTextOption("Tattoos from the '(excluded)' group will never","")
		AddTextOption("be picked.","")
		
		AddEmptyOption()
		AddEmptyOption()
		
		AddTextOption("I've included my personal categorization of","")
		AddTextOption("tattoos as the default value but you can change","")
		
		AddTextOption("it however you wish.","")
		AddEmptyOption()
		
		AddTextOption("The tattoo categorization date is stored","")
		AddTextOption("separately in a .json file on your hardrive in","")
		
		AddTextOption("(on windows 7)","")
		AddTextOption(".../My Games/Skyrim/JCUser/rTats/settings.json","")
		
		AddHeaderOption("Tattoo Addition/Removal")
		AddEmptyOption()
		
		AddTextOption("This is more of a general tattoo debugging thing.","")
		AddEmptyOption()
		
		AddTextOption("Click on the texture path of the tattoo to add","")
		AddTextOption("or remove the tattoo.","")
		
		AddTextOption("The Y/N beside the texture path indicate whether","")
		AddTextOption("the tattoo is currently applied","")
		return
	endif
	
	; Assumes it must be one of the tattoo setting pages
	int tatCount = JArray.count(tattooList)
	
	; Determines which tattoo page this is and by what to offset the tattoo list
	i = firstTattooPageIdx
	int tattooOffset = 0
	while i < firstTattooPageIdx + tattooPageCount
		if page == Pages[i]
			tattooOffset = (i - firstTattooPageIdx)*tattoosPerPage
		endif
		i += 1
	endwhile
	
	if tattooOffset >= tatCount
		AddTextOption("Unused Page","")
	else
		int idxLimit = tattooOffset + tattoosPerPage
		if tatCount < idxLimit
			idxLimit = tatCount
		endIf
		
		i = idxLimit - 1
		AddHeaderOption("Tattoos indexed " + tattooOffset + " to " + i)
		SetCursorFillMode(LEFT_TO_RIGHT)
		AddHeaderOption("Name & Assigned Set")
		AddHeaderOption("Texture Path")
		
		int currentTattoo = 0
		int tempOID
		bool isApplied
		i = tattooOffset
		while i < idxLimit
			currentTattoo = JArray.getObj(tattooList,i)
			
			tempOID = AddMenuOption(JMap.getStr(currentTattoo,"name"),getGroupForTattoo(currentTattoo))
			JIntMap.setInt(tattooOIDToIdxMap,tempOID,i)
			
			isApplied = menu_isTattooApplied(currentTattoo)
			if isApplied
				tempOID = AddMenuOption(JMap.getStr(currentTattoo,"texture"),"Y")
			else
				tempOID = AddMenuOption(JMap.getStr(currentTattoo,"texture"),"N")
			endif
			JIntMap.setInt(tattooTextureOIDToIdxMap,tempOID,i)
			
			i += 1
		endwhile
	endif
	
endevent

event OnOptionMenuOpen(int option)
	if JIntMap.hasKey(tattooTextureOIDToIdxMap,option)
		int idx = JIntMap.getInt(tattooTextureOIDToIdxMap,option)
		int tattooEntry = JArray.getObj(tattooList,idx)
		
		SetMenuDialogOptions(appliedOptions)
		if menu_isTattooApplied(tattooEntry)
			SetMenuDialogStartIndex(1)
		else
			SetMenuDialogStartIndex(0)
		endif
		
		SetMenuDialogDefaultIndex(0)
		
	elseif JIntMap.hasKey(tattooOIDToIdxMap,option)
		int idx = JIntMap.getInt(tattooOIDToIdxMap,option)
		int tattooEntry = JArray.getObj(tattooList,idx)
		int currentGroupIndex = getIndexForGroup(getGroupForTattoo(tattooEntry))
		
		SetMenuDialogOptions(tattooGroups)
		SetMenuDialogStartIndex(currentGroupIndex)
		SetMenuDialogDefaultIndex(0)
	endif
endevent

event OnOptionMenuAccept(int option, int index)
	if JIntMap.hasKey(tattooTextureOIDToIdxMap,option)
		int idx = JIntMap.getInt(tattooTextureOIDToIdxMap,option)
		int tattooEntry = JArray.getObj(tattooList,idx)
		
		bool isApplied = menu_isTattooApplied(tattooEntry)
		
		if index == 1 && !isApplied
			menu_applyTattoo(tattooEntry)
			SetMenuOptionValue(option,"Y")
		elseif index == 0 && isApplied
			menu_removeTattoo(tattooEntry)
			SetMenuOptionValue(option,"N")
		endif
		
	elseif JIntMap.hasKey(tattooOIDToIdxMap,option)
		int idx = JIntMap.getInt(tattooOIDToIdxMap,option)
		int tattooEntry = JArray.getObj(tattooList,idx)
		
		setGroupForTattoo(tattooEntry,tattooGroups[index])
		SetMenuOptionValue(option,tattooGroups[index])
	endif
endevent

event OnOptionSliderOpen(int option)
	if option == baseChanceOID
		SetSliderDialogStartValue(baseChance)
		SetSliderDialogDefaultValue(0.10)
		SetSliderDialogRange(0.0,1.0)
		SetSliderDialogInterval(0.01)
	elseif option == NpcbaseChanceOID
		SetSliderDialogStartValue(NpcbaseChance)
		SetSliderDialogDefaultValue(0.20)
		SetSliderDialogRange(0.0,1.0)
		SetSliderDialogInterval(0.01)
	elseif option == ZazbaseChanceOID
		SetSliderDialogStartValue(ZazbaseChance)
		SetSliderDialogDefaultValue(0.50)
		SetSliderDialogRange(0.0,1.0)
		SetSliderDialogInterval(0.01)
	elseIf option == chanceIncreaseOID
		SetSliderDialogStartValue(chanceIncrease)
		SetSliderDialogDefaultValue(0.07)
		SetSliderDialogRange(0.0,1.0)
		SetSliderDialogInterval(0.01)
	elseIf option == tattooDurationOID
		SetSliderDialogStartValue(tattooDurationHours)
		SetSliderDialogDefaultValue(168.0)
		SetSliderDialogRange(0.5,8760.0)
		SetSliderDialogInterval(0.5)
	elseIf option == NpctattooDurationOID
		SetSliderDialogStartValue(NpctattooDurationHours)
		SetSliderDialogDefaultValue(336.0)
		SetSliderDialogRange(0.5,8760.0)
		SetSliderDialogInterval(0.5)
	elseIf option == ZaztattooDurationOID
		SetSliderDialogStartValue(ZaztattooDurationHours)
		SetSliderDialogDefaultValue(672.0)
		SetSliderDialogRange(0.5,8760.0)
		SetSliderDialogInterval(0.5)
	endIf
endEvent

event OnOptionSliderAccept(int option, float value)
	if option == baseChanceOID
		baseChance = value
		SetSliderOptionValue(baseChanceOID, baseChance, "{2}")
	elseif option == NpcbaseChanceOID
		NpcbaseChance = value
		SetSliderOptionValue(NpcbaseChanceOID, NpcbaseChance, "{2}")
	elseif option == ZazbaseChanceOID
		ZazbaseChance = value
		SetSliderOptionValue(ZazbaseChanceOID, ZazbaseChance, "{2}")
	elseIf option == chanceIncreaseOID
		chanceIncrease = value
		SetSliderOptionValue(chanceIncreaseOID, chanceIncrease, "{2}")
	elseIf option == tattooDurationOID
		tattooDurationHours = value
		tattooDuration = tattooDurationHours / 24.0
		SetSliderOptionValue(tattooDurationOID, tattooDurationHours, "{1}")
	elseIf option == NpctattooDurationOID
		NpctattooDurationHours = value
		;tattooDuration = NpctattooDurationHours / 24.0 ; I'm not sure what this is for....
		SetSliderOptionValue(NpctattooDurationOID, NpctattooDurationHours, "{1}")
	elseIf option == ZaztattooDurationOID
		ZaztattooDurationHours = value
		;tattooDuration = NpctattooDurationHours / 24.0 ; I'm not sure what this is for....
		SetSliderOptionValue(ZaztattooDurationOID, ZaztattooDurationHours, "{1}")
	endIf
endEvent

event OnOptionSelect(int option)
	if option == debugOID
		debugEnabled = !debugEnabled
		SetToggleOptionValue(debugOID,debugEnabled)
		
	elseif option == permanentTattoosOID
		permanentTattoos = !permanentTattoos
		SetToggleOptionValue(permanentTattoosOID,permanentTattoos)
		
	elseif option == NpcpermanentTattoosOID
		NpcpermanentTattoos = !NpcpermanentTattoos
		SetToggleOptionValue(NpcpermanentTattoosOID,NpcpermanentTattoos)
		
	elseif option == ZazpermanentTattoosOID
		ZazpermanentTattoos = !ZazpermanentTattoos
		SetToggleOptionValue(ZazpermanentTattoosOID,ZazpermanentTattoos)
		
	elseif option == enableNotificationOID
		enableNotification = !enableNotification
		SetToggleOptionValue(enableNotificationOID,enableNotification)
		
	elseif option == overwriteColorOID
		overwriteColor = !overwriteColor
		SetToggleOptionValue(overwriteColorOID,overwriteColor)
		
	elseif option == overwriteGlossOID
		overwriteGloss = !overwriteGloss
		if overwriteGloss
			forceGloss = False
			SetToggleOptionValue(forceGlossOID,False)
		endif
		SetToggleOptionValue(overwriteGlossOID,overwriteGloss)
		
	elseif option == overwriteGlowOID
		overwriteGlow = !overwriteGlow
		if overwriteGlow
			forceGlow = False
			SetToggleOptionValue(forceGlowOID,False)
		endif
		SetToggleOptionValue(overwriteGlowOID,overwriteGlow)
		
	elseif option == forceGlowOID
		forceGlow = !forceGlow
		if forceGlow
			overwriteGlow = False
			SetToggleOptionValue(overwriteGlowOID,False)
		endif
		SetToggleOptionValue(forceGlowOID,forceGlow)
		
    ;----- Newly added options -------
	elseif option == allowFemaleOID
		allowFemale = !allowFemale
		SetToggleOptionValue(allowFemaleOID,allowFemale)
    elseif option == allowMaleOID
		allowMale = !allowMale
		SetToggleOptionValue(allowMaleOID,allowMale)
    elseif option == allowNPCOID
		allowNPC = !allowNPC
		SetToggleOptionValue(allowNPCOID,allowNPC)
    elseif option == onlyVictimOID
		onlyVictim = !onlyVictim
		SetToggleOptionValue(onlyVictimOID,onlyVictim)
    elseif option == excludeBeastialityOID
		excludeBeastiality = !excludeBeastiality
		SetToggleOptionValue(excludeBeastialityOID,excludeBeastiality)
    elseif option == enableNPCNotificationOID
		enableNPCNotification = !enableNPCNotification
		SetToggleOptionValue(enableNPCNotificationOID,enableNPCNotification)
    elseif option == useLockedTatsOID
		useLockedTats = !useLockedTats
		SetToggleOptionValue(useLockedTatsOID,useLockedTats)
     
	endIf
endEvent

event OnOptionColorAccept(int option, int color)
	if option == tattooColorOID
		tattooColor = color
	elseif option == glowColorOID
		glowColor = color
	endif
	SetColorOptionValue(option,color)
endEvent

event OnOptionHighlight(int option)
	if baseChanceOID == option
		SetInfoText("Base Chance that an aggressive sex act will trigger a tattoo")
	elseif NpcbaseChanceOID == option
		SetInfoText("Base Chance for NPCs that an aggressive sex act will trigger a tattoo")
	elseif ZazbaseChanceOID == option
		SetInfoText("Base Chance for NPCs in Zaz slave faction that an aggressive sex act will trigger a tattoo")
	elseif chanceIncreaseOID == option
		SetInfoText("For each tattoo trigger that is missed, the chance to receive a tattoo increased by this amount. If you want true randomness, set this to 0.")
	elseif tattooDurationOID == option
		SetInfoText("Duration that tattoo will remain (in game hours.) If permanent tattoos are enabled this option has no effect.")
	elseif NpctattooDurationOID == option
		SetInfoText("Duration that NPC tattoos will remain (in game hours.) If permanent tattoos are enabled this option has no effect.")
	elseif ZaztattooDurationOID == option
		SetInfoText("Duration that NPC in Zaz slave faction tattoos will remain (in game hours.) If permanent tattoos are enabled this option has no effect.")
	elseif permanentTattoosOID == option
		SetInfoText("Tattoos that get applied won't disappear on their own.")
	elseif NpcpermanentTattoosOID == option
		SetInfoText("NPC tattoos that get applied won't disappear on their own.")
	elseif ZazpermanentTattoosOID == option
		SetInfoText("Zaz slave faction NPC tattoos that get applied won't disappear on their own.")
	elseif debugOID == option
		SetInfoText("Enables debugging options. Currently this only lets you trigger a tattoo-addition event by pressing the 'N' key")
	elseif enableNotificationOID == option
		SetInfoText("If disabled, you won't receive a notification when a tattoo has been applied. For people who like surprises.")
	elseif overwriteColorOID == option
		SetInfoText("When a tattoo is applied by this mod, force the color to be something specific (this option doesn't work on all tattoos)")
		
	elseif overwriteGlossOID == option
		SetInfoText("When a tattoo is applied by this mod, force it to have no glossiness (most tattoos don't use glossiness)")
	elseif overwriteGlowOID == option
		SetInfoText("When a tattoo is applied by this mod, force it to have no glow effect (most tattoos don't use the glow effect)")
		
	elseif forceGlossOID == option
		SetInfoText("When a tattoo is applied by this mod, force it to have a glossiness effect")
	elseif forceGlowOID == option
		SetInfoText("When a tattoo is applied by this mod, force it to have a glow effect ")
		
	elseif tattooColorOID == option
		SetInfoText("If force-color is enabled, this color is applied (doesn't work on all tattoos)")
	elseif glowColorOID == option
		SetInfoText("If force-glow is enabled, this color is used for the glow effect")
    
    elseif allowFemaleOID == option
		SetInfoText("Female characters can be tattooed")
    elseif allowMaleOID == option
		SetInfoText("Male characters can be tattooed")
    elseif allowNPCOID == option
		SetInfoText("NPCs can be tattooed")
    elseif onlyVictimOID == option
		SetInfoText("Only victims (of a non-consenual sex act) may be tattooed")
    elseif excludeBeastialityOID == option
		SetInfoText("If true, scenes involving animals are ignored. Animals won't receive tattooes either way.")
    elseif enableNPCNotificationOID == option
		SetInfoText("Whether to display a message when an NPC gets tattooed")
    elseif useLockedTatsOID == option
		SetInfoText("If true, tattoos aren't removeable through this menu, nor the SlaveTats one. However if the tattoo is non-permenant it will still fade and expire on it's own.")
	endif
endEvent